package com.huigou.topsun.sap.nonProdApply.application.impl;


import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.huigou.topsun.base.bsnMessage.domain.BsnMessage;
import com.huigou.topsun.base.bsnMessage.repository.BsnMessageRepository;
import com.huigou.topsun.proofing.domain.proofingApply.model.ProofingApplyProcess;
import com.huigou.topsun.sap.nonProdApply.application.NonProdApplyDeptApplication;

import com.huigou.topsun.sap.nonProdApply.domain.SapNonProdApplyDept;
import com.huigou.topsun.sap.nonProdApply.repository.NonProdApplyDeptRepository;
import com.huigou.uasp.bmp.common.application.BaseApplication;

import com.huigou.util.SDO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class NonProdApplyDeptApplicationImpl extends BaseApplication implements NonProdApplyDeptApplication {

    @Autowired
    NonProdApplyDeptRepository nonProdApplyDeptRepository;
    @Autowired
    BsnMessageRepository bsnMessageRepository;

    @Override
    public Map<String,Object> saveSapNonProdApplyDept(SDO sdo) {
        Map<String,Object> map = new HashMap<>();
        SapNonProdApplyDept nonProdApplyDept = sdo.toObject(SapNonProdApplyDept.class);
        ObjectMapper objectMapper = new ObjectMapper();
        String deptStaffJSON = sdo.getString("deptStaff");
//        List<BsnMessage> processList = objectMapper.readValue(processJSON, new TypeReference<List<ProofingApplyProcess>>() {
//        });
        SapNonProdApplyDept save = nonProdApplyDeptRepository.save(nonProdApplyDept);

        map.put("applyDeptId",save.getApplyDeptId());
        return map;
    }

    @Override
    public void distributeSapNonProdApplyDept(SDO sdo) {
        Map<String, Object> map = this.saveSapNonProdApplyDept(sdo);
        List<BsnMessage> nonProdApplyDeptList = bsnMessageRepository.findAllByBusinessId((String) map.get("applyDeptId"));
        nonProdApplyDeptList.forEach(item->item.setActive(0));
        bsnMessageRepository.save(nonProdApplyDeptList);
    }

    @Override
    public SapNonProdApplyDept getNonProdApplyDeptById(String id) {
        return nonProdApplyDeptRepository.findOne(id);
    }

    @Override
    public void rejectNonProdApplyDept(SDO sdo) {
        String septString = sdo.getString("dept");
        //需要被驳回的部门
        List<String> deptList = Arrays.asList(septString.split(","));
        String bdid = sdo.getString("表单的id");
        //更改状态此对象为驳回状态
        SapNonProdApplyDept one = nonProdApplyDeptRepository.findOne(bdid);
        one.setStatus(2);
        nonProdApplyDeptRepository.save(one);
        //获取此条数据的相关部门信息
        List<BsnMessage> allByBusinessId = bsnMessageRepository.findAllByBusinessId(bdid);

    }
}
